/*
 *  Copyright (c) 1990 Regents of the University of Michigan.
 *  All rights reserved.
 *
 *  kerberos.c
 */

#ifndef lint 
static char copyright[] = "@(#) Copyright (c) 1990 Regents of the University of Michigan.\nAll rights reserved.\n";
#endif

#include "lber.h"
#include "ldap.h"

#ifdef KERBEROS

#include <stdio.h>
#include <string.h>
#include "krb.h"

/*
 * get_kerberosv4_credentials - obtain kerberos v4 credentials for ldap.
 * The dn and password of the entry to which to bind are supplied.
 */

/* ARGSUSED */
char *get_kerberosv4_credentials( ld, who, passwd, service, len )
LDAP	*ld;
char	*who;
char	*passwd;
char	*service;
int	*len;
{
	static KTEXT_ST	k;
	KTEXT		ktxt = &k;
	int		err;
	char		realm[REALM_SZ];

	Debug( LDAP_DEBUG_TRACE, "get_kerberosv4_credentials\n", 0, 0, 0 );

	if ( (err = krb_get_tf_realm( tkt_string(), realm )) != KSUCCESS ) {
#ifndef NO_USERINTERFACE
		fprintf( stderr, "krb_get_tf_realm failed (%s)\n",
		    krb_err_txt[err] );
#endif /* NO_USERINTERFACE */
		ld->ld_errno = LDAP_INVALID_CREDENTIALS;
		return( NULL );
	}

	if ( (err = krb_mk_req( ktxt, service, ld->ld_host, realm, 0 ))
	    != KSUCCESS ) {
#ifndef NO_USERINTERFACE
		fprintf( stderr, "krb_mk_req failed (%s)\n", krb_err_txt[err] );
#endif /* NO_USERINTERFACE */
		ld->ld_errno = LDAP_INVALID_CREDENTIALS;
		return( NULL );
	}

	*len = ktxt->length;
	return( (char *) ktxt->dat );
}

#endif
